//Activa a Communication Serial entre a aplicação Blynk e Monitor Serial:
#define BLYNK_PRINT Serial

#include  <ESP8266_Lib.h>  //Importar a "ESP8266_Lib" library.
#include  <BlynkSimpleShieldEsp8266.h>  //Importar a "BlynkSimpleShieldEsp8266" library.

//Autenticação da nossa conta na aplicação Blynk.
char auth[] = "ftNsgw91K48au76EAmHFjuOmpHzo7Qfk"; //Colocar o AuthToken da nossa aplicação. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

//Autenticação de acesso à rede Wi-Fi.
char ssid[] = "ZON-EF50"; //Colocar o nome da rede Wi-Fi. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
char pass[] = "8f4149b93b17"; //Colocar a password do rede Wi-fi. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        //Nota: Colocar "" caso seja uma rede Wi-Fi aberta.

//Activar a Communication Serial para o ESP8226 através de uma outra linha de comunicação:
#define EspSerial Serial1  //Selecciona a 2ª linha de Communication Serial.
#define ESP8266_BAUD 115200 //define a velocidade da Communication Serial com o ESP8266 ESP-01.
ESP8266 wifi(&EspSerial); //Activa a comunicação com ESP8266 ESP-01 através da linha selecionada.

//Variáveis para atribuição dos estados dos pinos virtuais dos botões de sentido de rotação do motor:
int Botao_Sentido_CW;
int Botao_Sentido_CCW;

//Variáveis para o pinos do Arduino de controlo do Motor e leitura do sensor RPM:
int Pino_Direccao_Motor_1= 2;
int Pino_Direccao_Motor_2 = 3;
int Pino_Sensor_RPM = 7;

//Variável para os cálculos da leitura de RPM:
int Contagem_Pulsos = 0; //Variável para a contagem de pulsos.
int Leitura_RPM;  //Variável para o cálculo da velocidade de rotação do motor.
int Disco_Num = 1;  //Variável para designação do numero de perfurações do disco do Sensor RPM.

//Definição dos pinos virtuais da aplicação Blynk e atribuição dos estados dos botões:
BLYNK_WRITE (V0) {
  Botao_Sentido_CW = param.asInt(); //Atribuir o estado do pino virtual à variável.
}
BLYNK_WRITE (V1) {
  Botao_Sentido_CCW = param.asInt();  //Atribuir o estado do pino virtual à variável.
}

//Correr a função SETUP apenas uma vez após ser pressionado Reset:
void setup() {
  //Iniciar a  Communication Serial a 9600b/s:
  Serial.begin(9600);
  //Iniciar Communication Serial com o ESP8266:
  EspSerial.begin(ESP8266_BAUD);
  
  //Atraso para o próximo passo.
  delay(10);
  
  //Iniciar ligação de rede Wifi:
  Blynk.begin(auth, wifi, ssid, pass);

  //Definição do tipo de pino (Saída ou Entrada):
  pinMode(Pino_Direccao_Motor_1, OUTPUT);
  pinMode(Pino_Direccao_Motor_2, OUTPUT);
  pinMode(Pino_Sensor_RPM, INPUT);
}

//A rotina de LOOP e executada repetidamente:
void loop() {
  //Inicia a comunicação com a aplicação Blynk.
  Blynk.run();

  //Condição para ligar o motor no sentido de rotação do relógio:
  if (Botao_Sentido_CW == HIGH) {
    //Definição do estado dos pinos para sentido de rotação do Motor CW: 
    digitalWrite(Pino_Direccao_Motor_1, LOW);
    digitalWrite(Pino_Direccao_Motor_2, HIGH);
  }
  //Condição para ligar o motor no sentido contrário da rotação do relógio:
  else if (Botao_Sentido_CCW == HIGH) {
    //Definição do estado dos pinos para sentido de rotação do Motor CCW:
    digitalWrite(Pino_Direccao_Motor_1, HIGH);
    digitalWrite(Pino_Direccao_Motor_2, LOW);
  }
  //Condição para desligar o motor:
  else if (Botao_Sentido_CW == LOW && Botao_Sentido_CCW == LOW) {
    //Definição do estado dos pinos para para o motor:
    digitalWrite(Pino_Direccao_Motor_1, LOW);
    digitalWrite(Pino_Direccao_Motor_2, LOW);
  }
  
  //Contagem do tempo de duração de cada pulso em nível Alto e nível Baixo.
  Contagem_Pulsos = (pulseIn(Pino_Sensor_RPM, HIGH) + pulseIn(Pino_Sensor_RPM, LOW));
  //Contagem de numero de pulsos por segundo (1Seg = 1000000µSeg).
  Leitura_RPM = 1000000/Contagem_Pulsos;
  //Converte Rotações por segundo (RPS) em Rotações por Minuto (RPM):
  Leitura_RPM = Leitura_RPM * 60;
  //Ajustar a leitura ao numero de perfurações do disco do sensor;
  Leitura_RPM = Leitura_RPM / Disco_Num;
  
  //Condição para que quando o motor está parado o valor seja 0 "zero":
  if (Leitura_RPM < 0){
    Leitura_RPM = 0;
  }
  else{
    Leitura_RPM = Leitura_RPM;
  }

  //Escreve na legenda o valor de RPM calculado:
  Blynk.virtualWrite(V2, Leitura_RPM);
  
  //Atraso para o próximo passo.
  delay(10);
}
